
// Assume label faceI defined

{
  label LC1 = faceOwnerOwner[faceI];
  label LC2 = mesh.faceOwner()[faceI];
  label LC3 = mesh.faceNeighbour()[faceI];
  label LC4 = faceNghbrNghbr[faceI];
  
  // Prepare for flux calculation
  scalar SX = mesh.Sf()[faceI].x();
  scalar SY = mesh.Sf()[faceI].y();
  scalar SZ = mesh.Sf()[faceI].z();
  
  scalar SH = ::sqrt(sqr(SX)+sqr(SY));  // No "sqrt" for scalar!
  scalar SL = mag(mesh.Sf()[faceI]);  // No mesh.magSf() on boundary!
  
  scalar SXH;
  scalar SYH;
  
  if (SH != 0.)
    {
      SXH = SX / SH;
      SYH = SY / SH;
    }
  else
    {
      SXH = 1.;
      SYH = 0.;
    }
  
  scalar SXL = SX / SL;
  scalar SYL = SY / SL;
  scalar SZL = SZ / SL;
  scalar SHL = SH / SL;
  
  scalar  rho_LC1 =  rho[LC1];
  scalar  rho_LC2 =  rho[LC2];
  scalar  rho_LC3 =  rho[LC2]; // Mirror rho
  scalar  rho_LC4 =  rho[LC1]; // Mirror rho
  
  vector    U_LC1 =    U[LC1];
  vector    U_LC2 =    U[LC2];
  // Zero velocity on wall
  vector    U_LC3 =    U[LC2] - 
    2.*vector((SX*U[LC2].x()+SY*U[LC2].y()+SZ*U[LC2].z())/SL*SX/SL,
	      (SX*U[LC2].x()+SY*U[LC2].y()+SZ*U[LC2].z())/SL*SY/SL,
	      (SX*U[LC2].x()+SY*U[LC2].y()+SZ*U[LC2].z())/SL*SZ/SL);
  vector    U_LC4 =    U[LC1] - 
    2.*vector((SX*U[LC1].x()+SY*U[LC1].y()+SZ*U[LC1].z())/SL*SX/SL,
	      (SX*U[LC1].x()+SY*U[LC1].y()+SZ*U[LC1].z())/SL*SY/SL,
	      (SX*U[LC1].x()+SY*U[LC1].y()+SZ*U[LC1].z())/SL*SZ/SL);
  
  vector rhoU_LC2 = rhoU[LC2];
  vector rhoU_LC3 = rhoU[LC2] - 
    2.*vector((SX*rhoU[LC2].x()+SY*rhoU[LC2].y()+SZ*rhoU[LC2].z())/SL*SX/SL,
	      (SX*rhoU[LC2].x()+SY*rhoU[LC2].y()+SZ*rhoU[LC2].z())/SL*SY/SL,
	      (SX*rhoU[LC2].x()+SY*rhoU[LC2].y()+SZ*rhoU[LC2].z())/SL*SZ/SL);
  
  scalar    p_LC1 =    p[LC1];
  scalar    p_LC2 =    p[LC2];
  scalar    p_LC3 =    p[LC2]; // Mirror p
  scalar    p_LC4 =    p[LC1]; // Mirror p
  
  scalar rhoE_LC2 = rhoE[LC2];
  scalar rhoE_LC3 = rhoE[LC2]; // Mirror rhoE
  
  scalar    c_LC2 =    c[LC2];
  scalar    c_LC3 =    c[LC2]; // Mirror c
  
  scalar F1;
  scalar F2;
  scalar F3;
  scalar F4;
  scalar F5;
  
  // Calculate flux over the face and put 
  // result in F1,F2,F3,F4,F5.
# include "cflux1.H"
  
  // Add flux to flux vectors
   Drho[LC2] =  Drho[LC2] - 1.0/mesh.V()[LC2] * F1;
  DrhoU[LC2] = DrhoU[LC2] - 1.0/mesh.V()[LC2] * vector(F2,F3,F4);
  DrhoE[LC2] = DrhoE[LC2] - 1.0/mesh.V()[LC2] * F5;
  
 
  //////////////////////////////
  // Face on step into domain //
  //////////////////////////////
  label faceIopp = 
    mesh.cells()[LC2].opposingFaceLabel(faceI, mesh.faces());
  
  LC1 = faceOwnerOwner[faceIopp];
  LC2 = mesh.faceOwner()[faceIopp];
  LC3 = mesh.faceNeighbour()[faceIopp];
  LC4 = faceNghbrNghbr[faceIopp];
  
  if (LC4 == -1)
    {
      // Prepare for flux calculation
      scalar SX = mesh.Sf()[faceIopp].x();
      scalar SY = mesh.Sf()[faceIopp].y();
      scalar SZ = mesh.Sf()[faceIopp].z();
      
      scalar SH = ::sqrt(sqr(SX)+sqr(SY));  // No "sqrt" for scalar!
      scalar SL = mag(mesh.Sf()[faceIopp]);  // No mesh.magSf() on boundary!
      
      scalar SXH;
      scalar SYH;
      
      if (SH != 0.)
	{
	  SXH = SX / SH;
	  SYH = SY / SH;
	}
      else
	{
	  SXH = 1.;
	  SYH = 0.;
	}
      
      scalar SXL = SX / SL;
      scalar SYL = SY / SL;
      scalar SZL = SZ / SL;
      scalar SHL = SH / SL;
      
      scalar  rho_LC1 =  rho[LC1];
      scalar  rho_LC2 =  rho[LC2];
      scalar  rho_LC3 =  rho[LC3];
      scalar  rho_LC4 =  rho[LC3]; // Mirror rho
      
      vector    U_LC1 =    U[LC1];
      vector    U_LC2 =    U[LC2];
      vector    U_LC3 =    U[LC3];
      // Zero velocity on wall
      vector    U_LC4 =    U[LC3] - 
	2.*vector((SX*U[LC3].x()+SY*U[LC3].y()+SZ*U[LC3].z())/SL*SX/SL,
		  (SX*U[LC3].x()+SY*U[LC3].y()+SZ*U[LC3].z())/SL*SY/SL,
		  (SX*U[LC3].x()+SY*U[LC3].y()+SZ*U[LC3].z())/SL*SZ/SL);
      
      vector rhoU_LC2 = rhoU[LC2];
      vector rhoU_LC3 = rhoU[LC3];
      
      scalar    p_LC1 =    p[LC1];
      scalar    p_LC2 =    p[LC2];
      scalar    p_LC3 =    p[LC3];
      scalar    p_LC4 =    p[LC3]; // Mirror p
      
      scalar rhoE_LC2 = rhoE[LC2];
      scalar rhoE_LC3 = rhoE[LC3];
      
      scalar    c_LC2 =    c[LC2];
      scalar    c_LC3 =    c[LC3];
      
      scalar F1;
      scalar F2;
      scalar F3;
      scalar F4;
      scalar F5;
      
      // Calculate flux over the face and put 
      // result in F1,F2,F3,F4,F5.
#     include "cflux1.H"
      
      // Add flux to flux vectors
       Drho[LC2] =  Drho[LC2] - 1.0/mesh.V()[LC2] * F1;
      DrhoU[LC2] = DrhoU[LC2] - 1.0/mesh.V()[LC2] * vector(F2,F3,F4);
      DrhoE[LC2] = DrhoE[LC2] - 1.0/mesh.V()[LC2] * F5;
      
       Drho[LC3] =  Drho[LC3] + 1.0/mesh.V()[LC3] * F1;
      DrhoU[LC3] = DrhoU[LC3] + 1.0/mesh.V()[LC3] * vector(F2,F3,F4);
      DrhoE[LC3] = DrhoE[LC3] + 1.0/mesh.V()[LC3] * F5;
    }
  else // LC1 == -1
    {
      // Prepare for flux calculation
      scalar SX = mesh.Sf()[faceIopp].x();
      scalar SY = mesh.Sf()[faceIopp].y();
      scalar SZ = mesh.Sf()[faceIopp].z();
      
      scalar SH = ::sqrt(sqr(SX)+sqr(SY));  // No "sqrt" for scalar!
      scalar SL = mag(mesh.Sf()[faceIopp]);  // No mesh.magSf() on boundary!
      
      scalar SXH;
      scalar SYH;
      
      if (SH != 0.)
	{
	  SXH = SX / SH;
	  SYH = SY / SH;
	}
      else
	{
	  SXH = 1.;
	  SYH = 0.;
	}
      
      scalar SXL = SX / SL;
      scalar SYL = SY / SL;
      scalar SZL = SZ / SL;
      scalar SHL = SH / SL;
      
      scalar  rho_LC1 =  rho[LC2]; // Mirror rho
      scalar  rho_LC2 =  rho[LC2];
      scalar  rho_LC3 =  rho[LC3];
      scalar  rho_LC4 =  rho[LC4];
      
      // Zero velocity on wall
      vector    U_LC1 =    U[LC2] - 
	2.*vector((SX*U[LC2].x()+SY*U[LC2].y()+SZ*U[LC2].z())/SL*SX/SL,
		  (SX*U[LC2].x()+SY*U[LC2].y()+SZ*U[LC2].z())/SL*SY/SL,
		  (SX*U[LC2].x()+SY*U[LC2].y()+SZ*U[LC2].z())/SL*SZ/SL);
      vector    U_LC2 =    U[LC2];
      vector    U_LC3 =    U[LC3];
      vector    U_LC4 =    U[LC4];
      
      vector rhoU_LC2 = rhoU[LC2];
      vector rhoU_LC3 = rhoU[LC3];
      
      scalar    p_LC1 =    p[LC2]; // Mirror p
      scalar    p_LC2 =    p[LC2];
      scalar    p_LC3 =    p[LC3];
      scalar    p_LC4 =    p[LC4];
	  
      scalar rhoE_LC2 = rhoE[LC2];
      scalar rhoE_LC3 = rhoE[LC3];
      
      scalar    c_LC2 =    c[LC2];
      scalar    c_LC3 =    c[LC3];
      
      scalar F1;
      scalar F2;
      scalar F3;
      scalar F4;
      scalar F5;
      
      // Calculate flux over the face and put 
      // result in F1,F2,F3,F4,F5.
#     include "cflux1.H"
      
      // Add flux to flux vectors
       Drho[LC2] =  Drho[LC2] - 1.0/mesh.V()[LC2] * F1;
      DrhoU[LC2] = DrhoU[LC2] - 1.0/mesh.V()[LC2] * vector(F2,F3,F4);
      DrhoE[LC2] = DrhoE[LC2] - 1.0/mesh.V()[LC2] * F5;
      
       Drho[LC3] =  Drho[LC3] + 1.0/mesh.V()[LC3] * F1;
      DrhoU[LC3] = DrhoU[LC3] + 1.0/mesh.V()[LC3] * vector(F2,F3,F4);
      DrhoE[LC3] = DrhoE[LC3] + 1.0/mesh.V()[LC3] * F5;
    }
}
