
// ~~~~~~~~~~~~~~~~~~ //


// List of face neighbours-neighbour
labelList faceOwnerOwner(mesh.nFaces());
labelList faceNghbrNghbr(mesh.nFaces());

// List of number of neighbours
labelList nfaceNghbrlist(mesh.nFaces());

// Init number and index list
forAll (nfaceNghbrlist, faceI)
{
  nfaceNghbrlist[faceI] = 0;
}


// Find how many neighbours neighbours
//Info<< "\nFaces nighbours-neighbours:" << endl;
//
for (label faceI = 0; faceI < mesh.nFaces(); faceI++)
{
  nfaceNghbrlist[faceI] = 4;
  
  label own = mesh.faceOwner()[faceI];
  label nei = mesh.faceNeighbour()[faceI];
  
  faceOwnerOwner[faceI] = -1;
  faceNghbrNghbr[faceI] = -1;
  
  
  // Owner side
  if (own == -1)
    {
      nfaceNghbrlist[faceI] -= 2;
    }
  else
    {
      
      label faceIoppOwn = 
	mesh.cells()[own].opposingFaceLabel(faceI, mesh.faces());
      
      if (faceIoppOwn >= mesh.nInternalFaces())
	{
	  nfaceNghbrlist[faceI]--;
	  //Info<< " face # " << faceI 
	  //<< " has an opposing face, # " << faceIoppOwn 
	  //<< ", at a boundary, at owner side" << endl;
	}
      
      label ownown =     mesh.faceOwner()[faceIoppOwn];
      label ownnei = mesh.faceNeighbour()[faceIoppOwn];
      
      // Owners owner
      if (own != ownown)
	{
	  faceOwnerOwner[faceI] = ownown;
	}
      else if (own != ownnei)
	{
	  faceOwnerOwner[faceI] = ownnei;
	}
    }
  
  // Neighbour side
  if (nei == -1)
    {
      nfaceNghbrlist[faceI] -= 2;
    }
  else
    {
      
      label faceIoppNei = 
	mesh.cells()[nei].opposingFaceLabel(faceI, mesh.faces());
      
      if (faceIoppNei >= mesh.nInternalFaces())
	{
	  nfaceNghbrlist[faceI]--;
	  //Info<< " face # " << faceI 
	  //<< " has an opposing face, # " << faceIoppNei 
	  //<< ", at a boundary, at neighbour side" << endl;
	}
      
      label neiown =     mesh.faceOwner()[faceIoppNei];
      label neinei = mesh.faceNeighbour()[faceIoppNei];
      
      // Neighbours neighbour
      if (nei != neiown)
	{
	  faceNghbrNghbr[faceI] = neiown;
	}
      else if (nei != neinei)
	{
	  faceNghbrNghbr[faceI] = neinei;
	}
    }
  
  //Info<< " face # " << faceI 
  //	  << " has " << nfaceNghbrlist[faceI] 
  //	  << " nghbrsnghbrs" << endl;
  //
  //Info<< " [" 
  //	  <<       faceOwnerOwner[faceI] << ", " 
  //	  <<     mesh.faceOwner()[faceI] << "," 
  //	  << mesh.faceNeighbour()[faceI] << "," 
  //          <<       faceNghbrNghbr[faceI] << "]" << endl;
  
}

// Found neighbours
